#ifndef __XMLIO_GROUP_TEMPLATE__
#define __XMLIO_GROUP_TEMPLATE__ 

namespace XMLIOSERVER
{
   template <class T>
      class GroupTemplate : public ObjectTemplate<GroupTemplate<T> >
   {
      public:
            
         GroupTemplate(void) : ObjectTemplate<GroupTemplate<T> >(), childList(), groupList()
         {/* Ne rien faire de plus */}               
         GroupTemplate(const string& _id) : ObjectTemplate<GroupTemplate<T> >(_id), childList(), groupList()
         {/* Ne rien faire de plus */}            
      
         virtual const char* getName(void) const {return ("GroupTemplate"); }
         
         /// Pour les groupes d'objets enfants ///
         
         GroupTemplate<T>& createGroup(const string _id) throw (XMLIOUndefinedValueException) 
         {
            GroupTemplate<T>& obj = GroupTemplate<T>::CreateObject(_id);
            groupList.addPtrObject(&obj);
            return (obj);
         }
         
         GroupTemplate<T>& createGroup(void)
         {
            GroupTemplate<T>& obj = GroupTemplate<T>::CreateObject();
            groupList.addPtrObject(&obj);            
            return (obj);
         }
         
         GroupTemplate<T>& getGroup(const string _id) throw (XMLIOUndefinedValueException) { return (*groupList[_id]); }
         bool hasGroup(const string _id) { return (groupList.hasMappedValue(_id)); }
         
         const StrHashMap<GroupTemplate<T>* >& getGroupList(void) { return (groupList); }
         
         size_t getNbGroup() const {return (groupList.getVectorSize()); }
         
         /// Pour les objets enfants ///
         
         T& createChild(const string _id) throw (XMLIOUndefinedValueException) 
         {
            T& obj = ObjectTemplate<T>::CreateObject(_id);
            childList.addPtrObject(&obj);
            return (obj);
         }
         
         T& createChild(void)
         {
            T& obj = ObjectTemplate<T>::CreateObject();
            childList.addPtrObject(&obj);            
            return (obj);
         }         
         
         T& getChild(const string _id) throw (XMLIOUndefinedValueException) { return (*childList[_id]); }
         bool hasChild(const string _id) { return (childList.hasMappedValue(_id)); }
         
         const StrHashMap<T*>& getCurrentListChild(void) { return (childList); }
         
         size_t getNbChild() const {return (childList.getVectorSize()); }
            
         static bool CLASS_TEST(ostream& log = std::clog)
         {
            GroupTemplate<T> group;
            /////////////////////////////////////////            
            GroupTemplate<T>& group0 = group.createGroup("toto");
            GroupTemplate<T>& group1 = group.createGroup();
            T& child0 = group.createChild("toto");
            T& child1 = group.createChild();
            log << "Nombre de (groupes) enfants : " << group.getNbChild() << "/" << group.getNbGroup() << " (2/2 attendu)" << std::endl;
            /////////////////////////////////////////
            log << "Test  GroupTemplate ... ok !" << std::endl;
            return (true);      
         };   

        
         ~GroupTemplate()
         {/* Ne rien faire de plus pour le moment */ }
         
      protected:
      
      private:
         StrHashMap<T*> childList;
         StrHashMap<GroupTemplate<T>* > groupList;

   }; // class GroupTemplate
   
   
   
}// namespace XMLIOSERVER


#endif // __XMLIO_GROUP_TEMPLATE__
